unit DS039u1;
(*Demonstration of access to ADC in DS2450.

N.B.: THis program is a VERY mixed bag....

It DOES work!... but there are some messy bits of programming.
It gives you more than the basic "read ADC"... which will...
.. annoy readers who just want to know how to read the ADC
        but... (see below)
.. benefit people who need a simple "read and log" program
.. benefit Delphi Tutorial readers: There are some useful
        examples in this of what you can do to give the user
        a convenient interface

To Annoyed Readers: While there is quite a bit of "other stuff"
        in this to ignore, the things you need are in....
               procedure ReadDS2450ADC;, and...
               function ConfigureADC:byte;
        Of course, both need a few things set before they will work.
               

========
First catch your rabbit... or in this case, get a DS2450 working
with the Viewer program supplied by Dallas with the SDK. You'll need
to know the chips ID code, anyway.

This program will not only show you how to read the DS2450, but it also,
not too confusingly, I hope, adds a "logging" feature which will just
be useful to some, and may be a useful example of Delphi programming
for others. The "Log" function merely lists in the memo what was seen
in the 4 ADC channels, making a new entry in the log any time any of
the channels changes by more than the amount set by the "sensitivity"
scrollbar.

NB: THE PROGRAM IS IN MID-CONVERSION to the "joys" of DS036eu use. It
WORKS, fine, but is untidy, with some stuff not done as well as it can
be, once the conversion is complete. DS036eu provides some consistently
structured routines to do many day-to-day TMEX calls. At the moment,
TMEX calls are coded within DS039 in more detail, and with worse error
checking, than is necessary when what DS036eu has to offer is available.
Hey! You wanted a perfect program? It would have been 5 years from now!

If you are using the DS2450 in the 1-Wire Weather Station VERSION THREE
(supplied by the people in Mexico, AAG)... you should know...

a) That hardware works with a DS9097U, but NOT(?) with a DS9097E
      (I think the strong pull up capability is needed because
       the temperature sensor (and/or ADC?) is(are) making demands).
       However: The DS2450 based circuit presented by Dan Awtrey
       in sensors magazine (www.sensorsmag.com/rticles/0501/34/main.shmtl)
       (which seems to be the basis of the direction sensing in the
       AAG device), plus the basic "Viewer" program from Dallas
       works fine with either adapter... so maybe strong pull-up
       is NOT needed? (I believe the DS0907E doesn't have the capability.
       (My version of his cirsuit uses two discrete diodes in place of
       the BAT54))

b) The inputs to the direction sensing DS2450 go up near 5v


Regardless of your hardware....

As far as the software is concerned, the basic idea is pretty simple....

Send code to the DS2450 to tell it what you want. This demo expects...
   All four channels used for ADC of analogue inputs.
   All configured for inputs of 0-5.10v.
   Eight bit resolution.
   No alarms in use.
   Vcc power, supplied from a 10uF capacitor charged by
       the 1-wire data/power line. (Awtrey circuit).

The configuration (Send code...(above)) only needs to happen once,
   unless the DS2450 gets reset, by, for instance, the MicroLan being
   disconnected. This simple demo program assumes the DS2450 is NOT
   reset. (Just restart the program if necessary to achieve reset.
   NB: In the above "reset" relates to reset of the DS2450, NOT a
   "mere" Microlan reset.)

Once the DS2450 is configured, you need to....

Send a "Convert" command (maybe arranging a period of strong pull-up if
   using parasitic power. Note this precludes using a DS9097E interface)
When the conversion is complete, (signaled on the MicroLan by the
   device), read the resulting values from within the DS2450.

Demo program does the config during OnCreateForm, and then uses
Timer1 to trigger new readings by the ADC from time to time.
Timer1 also causes the display to be updated after each re-reading.

*)

(*

Terminology: MicroLan, iButton and 1-Wire are all trademarks of Dallas
Semiconductors (now merged with Maxim). They relate to the same family
of chips. (iButton being a particular packaging method). This software
has not been reviewed or endorsed by Dallas, nor is the author associated
with them... other than as an appreciative customer! What I know about
MicroLan (a.k.a. 1-Wire) comes from studying generally available material
from Dallas. (Try www.ibutton.com, www.dalsemi.com and
www.arunet.co.uk/tkboyd/e1d.htm)

TMEX is Dallas's environment for MicroLan work. Program was developed
using TMEX 3.11 in a Win 3.11 environment. (The identical version
numbers are just coincidental.)

Also: copes poorly with absence of Dallas i/f to 1-wire.

Doesn't auto-detect either interface or chip IDs....
  but takes the IDs from an ini file.

*)

(*Dallas DO provide demos of reading MicroLan devices
as part of the SDK. They are available in several flavours,
including a Delphi versions. They are better programs than this
is... but you may find this helps you grasp the ESSENTIALS
without the distraction of flexibility and robustness that
should be present in any version of the program being
released for use by customers.

It seems that....
TMTouchByte(liSHandle,$AA);
is allowed, even thought it returns a value. I tend to use
iResult:=TMTouchByte(liSHandle,$AA);
even when I don't need the value in iResult.
It just seems tidier to me.*)

(*This demo doesn't show how to use some of the DS2450's
features... The chip can be set to raise "alarm" flags,
for the use of the MicroLan's general "find devices
reporting alarm conditions" provisions.
Nor does the demo cover using any of the pins normally
used as inputs to the 4 channel ADC as outputs, which
is possible if you don't need 4 channels.*)


interface
(*This program started life as a Delphi 2 app. It was moved to Delphi 1,
  at which time I first replaced the Uses clause with one from a Delphi
  1 App. It was then moved back to Delphi 2! There
  may be other issues, and there may be superfluous units.
  (iBTMEXPW was added by hand, being needed to access TMEX)
  DS036eu is an external unit written by me, available (free) from
  sheepdogguides.com/tut.htm*)

  uses SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus, ExtCtrls, iBTMEXPW,ds036eu;
  (*NB: To Use iBTMEXPW, several strategies are possible. It may also be
  possible to avoid the need for this entry in the uses clause. One easy
  (if inelegant) way to enable using the unit is to copy Ibtmexpw.pas
  (which comes from Dallas as part of the SDK) into the project's folder.*)


const ver ='10 May 05';
     (*DS039 derived from copy of DS005 online at 13 May 05
       DS005 has complex history.
       Name assigned 21 Sept 01 (Day after Nik's wedding)
       I started with 1-Wire after seeing note about Tini
       in Computer Shopper, Nov 2000. www.computershopper.co.uk*)
  boEightbit=true;(*Minor flag. If set true, ADC values
          (originally 16 bit) shifted right 8 places. I.e.
            1111000010101010 becomes 11110000*)

type

  TDS039f1 = class(TForm)
    buQuit: TButton;
    Memo1: TMemo;
    buHelp: TButton;
    paHelp: TPanel;
    meHelp: TMemo;
    buDoneWithHelp: TButton;
    meFile: TMemo;
    laADCa: TLabel;
    laADCb: TLabel;
    laADCc: TLabel;
    laADCd: TLabel;
    Label1: TLabel;
    Timer1: TTimer;
    Timer2: TTimer;
    RadioButton1: TRadioButton;
    buLog: TButton;
    ScrollBar1: TScrollBar;
    Label2: TLabel;
    laSens: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    sbSM: TScrollBar;
    sbML: TScrollBar;
    laSM: TLabel;
    laML: TLabel;
    procedure buQuitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure buHelpClick(Sender: TObject);
    procedure buDoneWithHelpClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Wink;
    procedure WaitAWhile;
    procedure buLogClick(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure sbSMChange(Sender: TObject);
    procedure sbMLChange(Sender: TObject);

  private
    { Private declarations }
    iADCa,iADCb,iADCc,iADCd:integer;(*Lousy programming but
            more clear this way*)
    rTmp:real;
    asTmp:string;(*IN DS001, this was ANSIString, allowing > 255 chars.
       All instances of asTmp fixed to less than 256 for Delphi 1. (No
       ANSIString in Delphi1... is there another way to get >255 chars
       in a memo line?*)
    sTmp,sTmp2:string;
    sChipID:string[16];
    iTmp,iTmp2:integer;
    iPortNum,iPortType,iResult,iFileHandle:smallint;
       (*N.B. Dallas TMEX (start of section 2.4 of SKD manual) says that
       "short" in their terminology is a 16 bit signed integer. In
       Delphi 1 that is called an integer (shortint being a signed
       8-bit number. I had smallint in a Delphi 2 version of this, but
       a) Smallint doesn't occur in Delphi1, pp help file (even though
       program compiles okay), and b) I'm not sure I checked that
       Delphi 2 defined smallint as 16 bit.*)
    liTmp,liSHandle:longint;
    baStateBuffer:array[0..15361] of byte; (*15360 might do*)
    siaRom:array[0..8] of smallint;(*8 in Dallas example, not 7...
        but things seen in Dallas doc suggests this (8) is a mistake.
        (7 would probably do just fine)
        If value in siaROM[0]or siaROM[7](one or other, but which
        ambiguous in docs) then certain functions using this transfer
        from the driver's array to the app's array, rather than vice
        versa*)

        (*Update older versions of the above comment to the relevant
        spot in older notes & demos about DS stuff*)

    baRomID:array[0..7] of byte;
    bTmp,bTmp2,bSens,bSM,bML,
    bADCaLast,bADCbLast,bADCcLast,bADCdLast:byte;
    boTmp,boShowMsgs,boLogging:boolean;
    bitmap:TBitMap;
    {rFO:TrTKFileOpener;}
    dfIn:file of byte;

    //The next four are needed by DS036eu routines, and the types are
    //       defined within DS036eu
    baDMLStateBuffer:TbaDMLStateBuffer;
    siaDMLRom:Tsia8;
    ssTKBErrRet:shortstring;
    iDalErrRet:integer;


    procedure ChkSess(bWhich:byte);
    procedure DebugMessages(boOn:boolean;liTmp:longint);
    procedure DebugMessagesWLoc(boOn:boolean;liTmp:longint;bLoc:byte);
    procedure ShowTMErrMessage(bErrLoc:byte;liErr:longint;sErr:string);
    function ConfigureADC:byte;
    procedure ReadDS2450ADC;

  public
    { Public declarations }
  end;

var
  DS039f1: TDS039f1;

implementation

{$R *.DFM}
{$R+} (*Turn on range checking. Unrelated to previous line
        which IS also needed.*)

procedure TDS039f1.ShowTMErrMessage(bErrLoc:byte;liErr:longint;sErr:string);
(*this is an unfinished bit of "cleverness"... but it works!*)
begin
DebugMessagesWLoc(boShowMsgs,liErr,bErrLoc);
(*qFIX Replace showmessage with something like printer error retry*)
showmessage(sERR+' '+inttostr(liErr)+' at location'+inttostr(bErrLoc));
end;

procedure TDS039f1.buQuitClick(Sender: TObject);
begin
application.terminate;
end;

function TDS039f1.ConfigureADC:byte;
(*ERROR DETECTION STILL TO BE WRITTEN. CURRENTLY (almost) ALWAYS RETURNS 0
  Returns 0 if set up successful*)
(*See other routines accessing DS chip for general documentation*)
var c1:byte;

begin (*ConfigureADC*)
if ssTKBErrRet='' then begin
  DMLExtStartAndSetup(liSHandle,iPortNum,iPortType,ssTKBErrRet,iDalErrRet); //<<Do more of these skeltons
  end;
if ssTKBErrRet<>'' then
//replace next with DS036eu version?
   ShowTMErrMessage(113,liSHandle,'TMExtendedStartSession once at GCV835 reported problem: ');
(*Note: SDK says TMSetup (part of DMLExtStartAndSetup) intended to be called once at start of appliction.
Maybe I'm over-using it? See also TMTouchReset*)

//Consider changing error report MECHANISM, but test is fine
if ssTKBErrRet<>'' then ShowTMErrMessage(115,iResult,'Be sure you have the right '+
   'Port Number and Adapter Type specified in the .ini file. '+
   'TMSetUp once at GCV842 reported problem: ');

if ssTKBErrRet='' then begin//block called "big block1"
for c1:=0 to 7 do siaROM[c1]:=baRomID[c1];
iResult:=TMRom(liSHandle,@baStateBuffer,@siaROM);
if iResult<>1 then
     ShowTMErrMessage(116,iResult,'GCVTMRom reported problem: ');

ChkSess(41);

(*This is remotely based on Read DS1994 Delphi example supplied
with SDK. Seems to work... but I suspect the error handling could
be more rigourous... especially after the changes I made.*)
if liSHandle>0 then begin (*2*)
 bTmp:=0;
 repeat
   if TMStrongAccess(liSHandle,@baStateBuffer)=1
       (*StrongAccess achieves Reset/Do SkipRom(CC) called for in
         DS2450 spec sheets*)

     then begin (*1*)

       iTmp2:=TMTouchByte(liSHandle,$55); (*Write Memory command*)
       iTmp2:=TMTouchByte(liSHandle,$08); (*Point to address $0008 to write...*)
       iTmp2:=TMTouchByte(liSHandle,$00); (*... control/status data*)

       iTmp2:=TMTouchByte(liSHandle,$08); (*Data for that address(Port A control)*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read CRC... could be processed for error trapping*)
          iTmp2:=TMTouchByte(liSHandle,$FF);(*Read 2nd byte of CRC*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read data... could be processed for error trapping*)
       iTmp2:=TMTouchByte(liSHandle,$01); (*Data for next address*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read CRC... could be processed for error trapping*)
          iTmp2:=TMTouchByte(liSHandle,$FF);(*Read 2nd byte of CRC*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read data... could be processed for error trapping*)
(*The two bytes of A's control now done. Now repeat for other three channels*)

       iTmp2:=TMTouchByte(liSHandle,$08); (*Data for next address(Port B control)*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read CRC... could be processed for error trapping*)
          iTmp2:=TMTouchByte(liSHandle,$FF);(*Read 2nd byte of CRC*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read data... could be processed for error trapping*)
       iTmp2:=TMTouchByte(liSHandle,$01); (*Data for next address*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read CRC... could be processed for error trapping*)
          iTmp2:=TMTouchByte(liSHandle,$FF);(*Read 2nd byte of CRC*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read data... could be processed for error trapping*)

       iTmp2:=TMTouchByte(liSHandle,$08); (*Data for next address(Port C control)*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read CRC... could be processed for error trapping*)
          iTmp2:=TMTouchByte(liSHandle,$FF);(*Read 2nd byte of CRC*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read data... could be processed for error trapping*)
       iTmp2:=TMTouchByte(liSHandle,$01); (*Data for next address*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read CRC... could be processed for error trapping*)
          iTmp2:=TMTouchByte(liSHandle,$FF);(*Read 2nd byte of CRC*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read data... could be processed for error trapping*)

       iTmp2:=TMTouchByte(liSHandle,$08); (*Data for next address(Port D control)*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read CRC... could be processed for error trapping*)
          iTmp2:=TMTouchByte(liSHandle,$FF);(*Read 2nd byte of CRC*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read data... could be processed for error trapping*)
       iTmp2:=TMTouchByte(liSHandle,$01); (*Data for next address*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read CRC... could be processed for error trapping*)
          iTmp2:=TMTouchByte(liSHandle,$FF);(*Read 2nd byte of CRC*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read data... could be processed for error trapping*)

       iResult:=TMTouchReset(liSHandle);(*Process result?*)
         if (iResult<>1) and (iResult<>2) then begin
           ShowTMErrMessage(115,iResult,'Problem at TMTouchRest of set up ADC');
         end;(*Else... all's well... 1 or 2 depends of whether alarming or
                non alarming presence pulse found*)
   end;(*1*)
   inc(bTmp);
until (bTmp>4) or (iResult=1) or (iResult=2);
   (*Looks like a 'try 4 times if MicroLan playing up' kludge...
      and is imperfect now, anyway... but may work, but involve odd
      overheads.*)
end;(*2*)

(*The next few lines appear to be a dangling scrap of old documentation....
Scrap?> Now write $40 to memory byte $1C to tell device that it will be Vcc
Scrap?> powered*)

ChkSess(61);

(*This is remotely based on Read DS1994 Delphi example supplied
with SDK. Seems to work... but I suspect the error handling could
be more rigourous... especially after the changes I made.*)
if liSHandle>0 then begin (*2*)
 bTmp:=0;
 repeat
   if TMStrongAccess(liSHandle,@baStateBuffer)=1
     then begin (*1*)

       iTmp2:=TMTouchByte(liSHandle,$55); (*Write Memory command*)
       iTmp2:=TMTouchByte(liSHandle,$1C); (*Point to address $001C to write...*)
       iTmp2:=TMTouchByte(liSHandle,$00); (*... control/status data*)

       iTmp2:=TMTouchByte(liSHandle,$40); (*Data for that address*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read CRC... could be processed for error trapping*)
          iTmp2:=TMTouchByte(liSHandle,$FF);(*Read 2nd byte of CRC*)
       iTmp2:=TMTouchByte(liSHandle,$FF);(*Read data... could be processed for error trapping*)

       (*Setup is now complete. I think we're now supposed to....
         Issue reset to restore all devices to "listening"...
         but I'm not sure. You won't find this in all editions of
         things written before this- my general intos, and DS2423 How To*)
       iResult:=TMTouchReset(liSHandle);(*Process result?*)
         if (iResult<>1) and (iResult<>2) then begin
           ShowTMErrMessage(115,iResult,'Problem at TMTouchRest of set up ADC');
         end;(*Else... all's well... 1 or 2 depends of whether alarming or
                non alarming presence pulse found*)
   end;(*1*)
   inc(bTmp);
until (bTmp>4) or (iResult=1) or (iResult=2);
   (*Looks like a 'try 4 times if MicroLan playing up' kludge...
      and is imperfect now, anyway... may work, but involve odd
      overheads.*)
end;(*2*)

if ssTKBErrRet='' then begin
   DMLEndSession(liSHandle,ssTKBErrRet,iDalErrRet);
   end;
if ssTKBErrRet<>'' then showmessage(sRepOfTKBAndDal(ssTKBErrRet,iDalErrRet));

end;//.. of "Big Block1"

if ssTKBErrRet='' then result:=0 //no ; here
  else result:=1;(*This is only a start.... error detection
                       and reporting needs improvement*)

end;(*ConfigureADC*)


procedure TDS039f1.FormCreate(Sender: TObject);
var w1:word;
    c1:byte;
(*FormCreate main block starts a long way down the page at...
"begin (**********************************************FormCreate"*)
procedure FillMemos;
begin
with memo1 do begin
clear;
asTmp:='This program (c) and written by TK Boyd, 5/05. ';
lines.add(asTmp);
asTmp:='Rights reserved, except: Please feel free to pass it on, so long as you '+
'credit the source and mention that the author can be found on the net '+
'as follows:';
lines.add(asTmp);
asTmp:='               http://sheepdogguides.com/tut.htm should be valid.';
lines.add(asTmp);
asTmp:='                             If it isn''t, search for Sheepdog Software.';
lines.add(asTmp);
asTmp:='     Now... how to keep conscience and lawyers happy? As novelists say, '+
'"I''d like to thank ... for the bits that are right, but all errors are mine." ';
lines.add(asTmp);
asTmp:='     Writing this software was only possible through studying the excellent '+
'examples provided by Dallas Semiconductor. That is covered by typical fierce copyright '+
'notices and licenses, so I hope that no one there is going to complain that ';
lines.add(asTmp);
asTmp:='this breaches anything. Their software certainly does these things better '+
'than mine does, but I hope mine helps you get started.';
lines.add(asTmp);
asTmp:='     The name "1-Wire" is a trademark of Dallas '+
'Semiconductor. Visit them at www.ibutton.com. The author of '+
'this program is not connected with them, nor is the program endorsed '+
'by them.';
lines.add(asTmp);
end; (*With memo1*)

with meHelp do begin
clear;
asTmp:='''MicroLan'', etc, are TM of Dallas Semiconductor. '+
'See www.dalsemi.com and www.arunet.co.uk/tkboyd/e1didx.htm';
lines.add(asTmp);
lines.add(' ');
asTmp:=''+
''+
'';
lines.add(asTmp);
lines.add(' ');
asTmp:=''+
''+
'';
lines.add(asTmp);
lines.add(' ');
end; (*With memo2*)
end;(*FillMenoms*)

procedure CheckIniFile;
var c1:byte;
    sFiNam,sFiHead:string;
begin
sFiNam:='DS039ini.txt';
boTmp:=false;(*If true later, file existed and data in it was valid*)
if fileexists(sFiNam) then begin
  boTmp:=true;
  with meFile do begin
  lines.loadfromfile(sFiNam);
  sFiHead:='aaDS039ini.txt file';
  if lines[0]<>sFiHead then begin(*3*)
    showmessage('1st line of ini file must be: "+sFiHead+" '+ chr(13)+
    'Program will terminate');
    application.terminate;
    boTmp:=false;(*in case app doesn't terminate...*)
    end;(*3*)

(*Dallas demos (in Delphi) show more elegant and robust versions
of the following initialisation code...
iPortNum is sets which COM port to look for adapter on.
iPortNum is sets to Adapter Type code (Dallas's code: 1 for DS9097E,
    5 for 9097-U, see Dallas docs for others)
Dallas recommend a call to TMGetTypeVersion here to verify port
type. There are other things you would also do in a more robust program
to ensure all was well with the system before attempting to use it.*)


  sTmp:=copy(lines[1],1,1);
  if pos(sTmp,'0123456789')=0 then begin(*3*)
     showmessage('1st char of second line sets the port the adapter is on. '+
     'It doesn''t seem to be a digit. Application will terminate.');
     application.terminate;(*Can anyone tell me why this didn't prevent
     and attempt at iPortNum:=strtoint(sTmp); (two lines down) when
     sTmp was equal to 'x'? The message appeared, as expected.*)
     boTmp:=false;(*in case app doesn't terminate...*)
     end;(*3*)
     iPortNum:=strtoint(sTmp);

  sTmp:=copy(lines[2],1,1);
  if pos(sTmp,'0123456789')=0 then begin(*3*)
     showmessage('1st char of third line sets the adapter type code. '+
     'It doesn''t seem to be a digit. Application will terminate.');
     application.terminate;(*Can anyone tell me why this didn't prevent
     and attempt at iPortNum:=strtoint(sTmp); (two lines down) when
     sTmp was equal to 'x'? The message appeared, as expected.*)
     boTmp:=false;(*in case app doesn't terminate...*)
     end;(*3*)
     iPortType:=strtoint(sTmp);

  sTmp:=copy(lines[3],1,4);
  if uppercase(sTmp)<>'IDA:' then begin(*3*)
    showmessage('Fourth line of ini file must start "IDA:". '+
    'Program will terminate');
    application.terminate;
    boTmp:=false;(*in case app doesn't terminate...*)
    end;(*3*)

  if length(lines[3])<>20 then begin(*3*)
    showmessage('Fourth line of ini file must be 20 characters long. '+
    '(Put no space after "IDA:") '+
    'Program will terminate');
    application.terminate;
    boTmp:=false;(*in case app doesn't terminate...*)
    end;(*3*)

  sChipID:=uppercase(copy(lines[3],5,16));
  for c1:=1 to 16 do
    if pos(copy(sChipID,c1,1),'0123456789ABCDEF')=0 then begin(*3*)
       showmessage('There is an invalid character in the chip '+
       'ID. (Only 0-9, a-f, A-F allowed.) Application will terminate.');
       application.terminate;
       boTmp:=false;(*in case app doesn't terminate...*)
       end;(*3*)

   if copy(sChipID,15,2)<>'20' then begin(*3*)
    showmessage('The id you gave for the counter is not for a DS2450. (LSB would '+
    'be 20 for that device.) Program could be expanded to work with '+
    'other devices, but has not been yet. Program will terminate');
    application.terminate;
    boTmp:=false;(*in case app doesn't terminate...*)
    end;(*3*)

  end;(*with meFile*)

  end; (*...of processing of aaDS039ini.txt*)

  if boTmp=false then begin
  showmessage('Unlike most programs from Sheepdog Software, '+
  'an .ini file is needed. It must be called DS039ini.txt and be '+
  'in the same folder as DS039.exe');
  showmessage('The ini file must consist of the following....'+#13+#13+
  'aaDS039ini.txt file'+#13+
  '2 <-1st char determines port where adapter is.'+#13+
  '5 <-1st char determines adapter type (see next msg)'+#13+
  'IDA:<followed by 16 digit id of DS2450, counter>');
  (*Possible .ini file follows.
  First 2 characters indicate the ini file format version.
  The second line determines whether the program
       writes temperature data to a log file.
  String after IDA: WILL need changing. One easy way to find
       your chip's id is to use the Dallas supplied iViewer.
Possible DS005.ini follows. Everything between the ===s
=====================================================
aaDS039ini.txt file
2 <-1st char determines port where adapter is.
5 <-1st char determines adapter type (see next msg)
IDA:1C000000010D3C20
=====================================================
*)


  showmessage('For adapter type in ini file:'+#13+
  '     5 for DS9097U'+#13+
  '     1 for DS9097E'+#13+#13+
  'Program will now terminate.');
  application.terminate;
  end;(*if boTmp=false...no DS039ini.txt found, or it was faulty*)
if boTmp=false then application.terminate;(*Should have terminated
   before this if boTmp=false, but sometimes fails to so so in
   similar situations. "Belt and braces" code.*)
end;(*CheckIniFile*)

begin (**********************************************FormCreate*)
boLogging:=false;//Flag that we are not currently logging.
buLog.caption:='Log';//Used as flag within OnbuLogClick, to show first click

bSM:=sbSM.position;
bML:=sbML.position;
laSM.caption:=inttostr(bSM);
laML.caption:=inttostr(bML);

bSens:=scrollbar1.position;
laSens.caption:=inttostr(bSens);
ssTKBErrRet:='';//flags no problem found... yet... with DS036eu calls
if copy(DS036Version,1,3)<>'aca' then showmessage('There may be a problem with the '+
   'version of DS036eu you are using. There''s no harm in pressing on, '+
   'hoping for the best!');

timer1.interval:=300;
timer2.interval:=30;
meFile.hide;(*Only a receptacle for contents of DS039ini.txt*)
meFile.Wordwrap:=false;(*Necessary when using a memo to hold ini files, etc*)
boShowMsgs:=not true;(*When false: suppresses some debugging messages*)
paHelp.hide;
radiobutton1.show;

application.title:='DS039';
caption:='DS039- Read DS2450 ADC.  Ver: '+ver;

CheckIniFile;

baRomID[7]:=strtoint('$'+copy(sChipID,1,2)); (*MSB of chip's unique id.*)
baRomID[6]:=strtoint('$'+copy(sChipID,3,2));
baRomID[5]:=strtoint('$'+copy(sChipID,5,2));
baRomID[4]:=strtoint('$'+copy(sChipID,7,2));
baRomID[3]:=strtoint('$'+copy(sChipID,9,2));
baRomID[2]:=strtoint('$'+copy(sChipID,11,2));
baRomID[1]:=strtoint('$'+copy(sChipID,13,2));
baRomID[0]:=strtoint('$'+copy(sChipID,15,2));

(*In typical Delphi work, you would set these initial values with
the IDE, but I wanted such things in the source code because this
is written to demonstrate using the MicroLan devices*)

FillMemos;

bTmp:=ConfigureADC;
(*Eventually, will return 0 only if no error. Currently always returns 0*)
Timer1.enabled:=true;(*Turn on convert & display once per Timer1 timeout.*)
end; {OnFormCreate}

procedure TDS039f1.DebugMessages(boOn:boolean;liTmp:longint);
   begin
   if boOn then showmessage('A TMEX call returned '+inttostr(liTmp));
   end;

procedure TDS039f1.DebugMessagesWLoc(boOn:boolean;liTmp:longint;bLoc:byte);
   begin
   if boOn then showmessage('A TMEX call returned '+inttostr(liTmp)+
     ' at location '+inttostr(bLoc));
   end;

procedure TDS039f1.ChkSess(bWhich:byte);
  (*Should not be called before there is an at-least-once-valid
    number in liSHandle.
    Check session still valid, restore if necessary*)
  begin
   iResult:=TMValidSession(liSHandle);
   if iResult<>1 then begin
   (*qfix... all such should not be showmessage because it is modal.
     should also probably incorp delay-before-proceed*)
     showmessage('Something made session invalid at check '+
        inttostr(bWhich)+'. Problem was: '+
        inttostr(iResult)+'. Re-establishing.');
     //EstablishSession;
     if ssTKBErrRet='' then begin
        DMLExtStartAndSetup(liSHandle,iPortNum,iPortType,ssTKBErrRet,iDalErrRet);// routine in DS036eu
        end;
     end;
   end;

procedure TDS039f1.buHelpClick(Sender: TObject);
begin
paHelp.show;
radiobutton1.hide;
paHelp.align:=alclient;
meHelp.align:=alclient;
buDoneWithHelp.top:=meHelp.height-25;
buDoneWithHelp.left:=meHelp.width-65;
end;

procedure TDS039f1.buDoneWithHelpClick(Sender: TObject);
begin
paHelp.hide;
radiobutton1.show;
end;

procedure TDS039f1.WaitAWhile;
(*This is a mess! Ignore it! I've left in place three approaches
to achieving a delay. Program seems to work without delay.
In any case, the way I was calling WaitAWhile didn't seem to
result in a delay, anyway!
One of the approaches is a really messy way to get a delay,
and one I don't even fully trust!
Determination of "required"(?) duration of necessary Strong Pull Up is
not simple, but 4ms is enough for 4 channels at 12bit resolution*)
begin
{plan A}
{maybe sleep(100) is what I need here?;}

{Plan B (only use of Timer2 in program)
Timer2.enabled:=true;
boTmp:=true;
while boTmp do application.processmessages;}

{Plan C, a method I trust more,
but which may only work in Delphi2..
gettickcount increments about once per millisecond.
See http://www.drbob42.com/uk-bug/hood-08.htm for
a full discussion.
Because of overflow, this approach will misbehave
once in 49 days.

{liTmp:=gettickcount+200;
while gettickcount<liTmp do application.processmessages;}
end;

procedure TDS039f1.ReadDS2450ADC;
(*Should only be called AFTER ADC has been set up.
  Three parts...
    Cause conversion and wait for completion
    Read data
    Pass to global variables iADCa, iADCb, iADCc, iADCd
      (Use of globals is contrary to my usual preference, but
       here perhaps it makes the code easier to follow)  *)
var iADCaL,iADCbL,iADCcL,iADCdL:integer;(*Local variables for ADC values*)
    c1:byte;

begin
iADCaL:=0;(*Init, in case call to DS2450 fails*)
iADCbL:=0;iADCcL:=0;iADCdL:=0;

(*Next: Cause conversion....*)
liSHandle:=TMExtendedStartSession(iPortNum,iPortType,nil);(*Should return >0*)
if liSHandle<1 then
   ShowTMErrMessage(143,liSHandle,'TMExtendedStartSession once at CC835 reported problem: ');

iResult:=TMSetUp(liSHandle);
if iResult<>1 then ShowTMErrMessage(145,iResult,'Be sure you have the right '+
   'Port Number and Adapter Type specified in the .ini file. '+
   'TMSetUp once at CC842 reported problem: ');

(*qfix.. edit*)
(*REVISE TO REFLECT GRASP OF SETUP/RESET DISTINCTION>>>>>Dallas docs say
this resets all devices on net. Also say that it should
be called once at start of APPLICATION... but suggest that needs calling
between TMExtendedStartSession and any other TM functions. The code here
works... but maybe a TMExtendedStartSession and ONE TMSetUp in
OnFormCreate, with subsequent TMExtendedStartSessions not having TMSetUp
would be right & entail less overhead? (I think that just one
TMExtendedStartSession is not sufficient for the whole app's run.)*)

for c1:=0 to 7 do siaROM[c1]:=baRomID[c1];
(*repeatedly refilling may not be necessary. If the previous
line is right, some Dallas docs are less than fully clear (to me)
on some important matters regarding the last parameter of TMRom

My grasp of using TMEX is a work in progress. An example...
We know that in the code we write we can set up arrays, e.g. baRomID.
We know that there are groups of bytes in the hardware, e.g. the DS2405,
   which we want to know about.
Less obvious is a scratchpad which I think exists within the driver
   between our program and the hardware.
I THINK the essential point is that TMRom doesn't directly read/write the
    hardware. Rather, it reads/writes the scratchpad. Other routines
    cause things to go between the scratchpad and the hardware in due season.
If the first element of the last parameter of TMRom is 0, TMRom will read
    from the scratchpad. The implication of this is that no device would
    have a device ID with 0 in this byte... otherwise there would be no
    way to put the relevant device id in the scratchpad prior to an
    "access <that> device" call... but this seems a reasonable constraint
    that the MicroLan designers may have accepted.
*)

iResult:=TMRom(liSHandle,@baStateBuffer,@siaROM); (*Load buffer in
  s/w driver with ID of chip to be accessed.*)
  (*if iResult=1 after call, transfer succeeded*)
if iResult<>1 then
     ShowTMErrMessage(146,iResult,'CC TMRom reported problem: ');

ChkSess(241);(*Shouldn't be necessary, but.... Check session and
   re-establish if necessary.*)

(*This is remotely based on Read DS1994 Delphi example supplied
with SDK. Seems to work... but I suspect the error handling could
be more rigourous... especially after the changes I made.*)
if liSHandle>0 then begin (*1*)
   if TMStrongAccess(liSHandle,@baStateBuffer)=1
     then begin (*2*)
       iResult:=TMTouchByte(liSHandle,$3C); (*Convert command*)
       iResult:=TMTouchByte(liSHandle,$0F); (*Send Select mask. ($0F: All channels)*)
       iResult:=TMTouchByte(liSHandle,$00); (*Send Read-Out Control byte ($00: no preset)*)

(*If you want to use strong pull up, there are two parts. This is 1st..
Set up for strong pull up.
Not all adapters can do a strong pull up, which is needed(?) with
a DS2450 if the DS2450 is using parasitic power. Following code requests
adapter to 0,1,1: be set(0) for strong pull up(1), primed to happen
after next TMTouchByte()*)
{iResult:=TMOneWireLevel(liSHandle,0,1,2);
if (iResult<0)
 then ShowTMErrMessage(31,iResult,'TMOneWireLevel reported problem: ');}
ChkSess(142);

iResult:=TMTouchByte(liSHandle,$FF);(*Read CRC... could be used for error
       checking... and the TMTouchByte starts period of strong pull up*)
  iTmp2:=TMTouchByte(liSHandle,$FF);(*Read 2nd byte of CRC*)
(*There probabably needs to be a delay here, but I never got
it working right, though my program works... if ReadDS2450 not called
too often....*)
{latmp.caption:='in spu'; (*for debugging WaitAWhile*)
application.processmessages;
WaitAWhile;}
(*...keeping 1-Wire in Strong Pull Up long enough for needs of
parasitic power, *)
(*Next is part of debugging WaitAWhile*)
{application.processmessages;
latmp.caption:='not in spu';
application.processmessages;}

      ChkSess(3);

      (*If strong pull up wanted...
       Request adapter to 0,0,1: be set(0) back to normal state (0), now (0)*)
      {TMOneWireLevel(liSHandle,0,0,0);   }
      (*qfix... is there an error code to check from above?*)

      (*Now wait for completion of conversion follows...*)
       while TMTouchByte(liSHandle,$FF)<>$FF do application.processmessages;(*Wait or completion of conversion, without upsetting Windows.*)
   end (*no ; here. End of "then begin *2*"*)
   else begin (*2*)
     (*deal with failure of call*)
     end; (* else *2*)

       (*Call for Convert is now complete. We're now supposed to
       issue a reset to restore all devices to "listening"...
         This is NEEDED after a "convert", and probably desireable
         in other"command finished situations,
         but I'm not sure. You won't find this in all editions of
         things written before this- my general intros, and DS2423 How To*)

   iResult:=TMTouchReset(liSHandle);(*Process result?*)
   if (iResult<>1) and (iResult<>2) then begin
         ShowTMErrMessage(246,iResult,'Problem at TMTouchRest of Call for Convert');
         end;(*Else: all's well... 1 or 2 depends of whether alarming or
                non alarming presence pulse found*)

(*Read data from DS2450 follows....*)

(*This is remotely based on Read DS1994 Delphi example supplied
with SDK. Seems to work... but I suspect the error handling could
be more rigourous... especially after the changes I made.*)
if liSHandle>0 then begin (*2*)
   if TMStrongAccess(liSHandle,@baStateBuffer)=1
     then begin (*3*)
       iResult:=TMTouchByte(liSHandle,$AA); (*Read Memory command*)
       iResult:=TMTouchByte(liSHandle,$00); (*Point to page 0 to read ADC values*)
       iResult:=TMTouchByte(liSHandle,$00); (*... second byte to spec page*)

(*Read and accumulate the four two byte words of the conversions...
    They are delivered LSB first*)

       iADCaL:=TMTouchByte(liSHandle,$FF);
       if not boEightbit then iADCaL:=iADCaL+256*TMTouchByte(liSHandle,$FF)(*no ; here*)
         else iADCaL:=TMTouchByte(liSHandle,$FF);

       iADCbL:=TMTouchByte(liSHandle,$FF);
       if not boEightbit then iADCbL:=iADCbL+256*TMTouchByte(liSHandle,$FF)(*no ; here*)
         else iADCbL:=TMTouchByte(liSHandle,$FF);

       iADCcL:=TMTouchByte(liSHandle,$FF);
       if not boEightbit then iADCcL:=iADCcL+256*TMTouchByte(liSHandle,$FF)(*no ; here*)
         else iADCcL:=TMTouchByte(liSHandle,$FF);

       iADCdL:=TMTouchByte(liSHandle,$FF);
       if not boEightbit then iADCdL:=iADCdL+256*TMTouchByte(liSHandle,$FF)(*no ; here*)
         else iADCdL:=TMTouchByte(liSHandle,$FF);
(*Some error checking should probably be added....*)
       iResult:=TMTouchByte(liSHandle,$FF);(*Fetch CRC for page of data*)
          iTmp2:=TMTouchByte(liSHandle,$FF);(*Read 2nd byte of CRC*)

(*Read ADC conversions now complete. I think we should now....
         Issue reset to restore all devices to "listening"...
         but I'm not sure. You won't find this in all editions of
         things written before this- my general intos, and DS2423 How To*)
       iResult:=TMTouchReset(liSHandle);(*Process result?*)
         if (iResult<>1) and (iResult<>2) then begin
           ShowTMErrMessage(115,iResult,'Problem at TMTouchRest of set up ADC');
         end;(*Else... all's well... 1 or 2 depends of whether alarming or
                non alarming presence pulse found*)

   end;(*of "then begin *3*"*)
end;(*of "then begin *2*"*)

if ssTKBErrRet='' then begin
   DMLEndSession(liSHandle,ssTKBErrRet,iDalErrRet);
   end;
if ssTKBErrRet<>'' then showmessage(sRepOfTKBAndDal(ssTKBErrRet,iDalErrRet));


(*Pass to global variables iADCa, iADCb, iADCc, iADCd
      (Use of globals is contrary to usual practice, but
       perhaps makes code easier to follow)  *)
iADCa:=iADCaL;
iADCb:=iADCbL;
iADCc:=iADCcL;
iADCd:=iADCdL;
end(*no ; here. End of "then begin *1*"*)
else begin (*1*)
//handle error
end;(*of "else begin *1*"*)
end;(*ReadDS2450ADC*)

procedure TDS039f1.Wink;
(*Just a little visual indication to reassure user program
  hasn't frozen.*)
begin
  if RadioButton1.checked then RadioButton1.checked:=false (*no ; here*)
           else RadioButton1.checked:=true;
end;

procedure TDS039f1.Timer1Timer(Sender: TObject);
   function chrSML(bTmp:byte):char;
     //returns "S", "M" or "L" for small, medium, large,
     //   depending how big bTmp is.
   begin
   result:='M';// for now, anyway....
   if bTmp<bSM then result:='S';
   if bTmp>bML then result:='L';
   end;
begin //Timer1Timer
ReadDS2450ADC;
//I believe that the values in iADCa-d are in range 0-255 by now... maybe not.
laADCa.caption:=inttostr(iADCa);
laADCb.caption:=inttostr(iADCb);
laADCc.caption:=inttostr(iADCc);
laADCd.caption:=inttostr(iADCd);
if boLogging then begin
if
  (abs(iADCa-bADCaLast)>=bSens) or
  (abs(iADCb-bADCbLast)>=bSens) or
  (abs(iADCc-bADCcLast)>=bSens) or
  (abs(iADCd-bADCdLast)>=bSens)
then begin
memo1.lines.add(inttostr(iADCa)+chr(9)+
   inttostr(iADCb)+chr(9)+
   inttostr(iADCc)+chr(9)+
   inttostr(iADCd)+chr(9)+
   chrSML(iADCa)+chr(9)+
   chrSML(iADCb)+chr(9)+
   chrSML(iADCc)+chr(9)+
   chrSML(iADCd));
bADCaLast:=iADCa;
bADCbLast:=iADCb;
bADCcLast:=iADCc;
bADCdLast:=iADCd;
   end;
   end; //if boLogging..
Wink;
end;

procedure TDS039f1.Timer2Timer(Sender: TObject);
(*Timer2's only role was in one of my "WaitAWhile" schemes.*)
begin
boTmp:=false;
Timer2.enabled:=false;
end;

procedure TDS039f1.buLogClick(Sender: TObject);
begin
if buLog.caption='Log' then memo1.clear;
if boLogging=false then begin
//set up some initial values in the 4 "last" bytes, values which
//  probably will not occur on the first read of the device
bADCaLast:=1;
bADCbLast:=55;
bADCcLast:=200;
bADCdLast:=254;
boLogging:=true;//should make this button capable of turning OFF logging, too...
buLog.caption:='Stop Log';
end // no ; here. End of Start logging
else begin // stop logging.
memo1.lines.add('- - - Stopped here - - -');
boLogging:=false;
buLog.caption:='Resume Log';
end;//stop logging
end;

procedure TDS039f1.ScrollBar1Change(Sender: TObject);
begin
bSens:=scrollbar1.position;
laSens.caption:=inttostr(bSens);
end;

procedure TDS039f1.FormResize(Sender: TObject);
begin
memo1.height:=DS039f1.height-(408-205);
end;

procedure TDS039f1.sbSMChange(Sender: TObject);
begin
bSM:=sbSM.position;
laSM.caption:=inttostr(bSM);
end;

procedure TDS039f1.sbMLChange(Sender: TObject);
begin
bML:=sbML.position;
laML.caption:=inttostr(bML);
end;

end.
